gtkmm: Gdk::DragSurfaceImpl Class Reference

gtkmm 4.23.2

Public Member Functions | List of all members
Gdk::DragSurfaceImpl Class Reference

Gdk::DragSurfaceImpl is a Gdk::Surface that implements the Gdk::DragSurface interface. More...

`#include <gdkmm/dragsurfaceimpl.h>`

Inheritance diagram for Gdk::DragSurfaceImpl:
[legend]

## Public Member Functions
| DragSurfaceImpl (DragSurfaceImpl && src) noexcept
DragSurfaceImpl & | operator= (DragSurfaceImpl && src) noexcept
| ~DragSurfaceImpl () noexcept override
Public Member Functions inherited from Gdk::DragSurface
| DragSurface (DragSurface && src) noexcept
DragSurface & | operator= (DragSurface && src) noexcept
| ~DragSurface () noexcept override
GdkDragSurface * | gobj ()
| Provides access to the underlying C GObject.
const GdkDragSurface * | gobj () const
| Provides access to the underlying C GObject.
bool | present (int width, int height)
| Present drag_surface.
Glib::SignalProxy< void(DragSurfaceSize &)> | signal_compute_size ()
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gdk::Surface
| Surface (Surface && src) noexcept
Surface & | operator= (Surface && src) noexcept
| ~Surface () noexcept override
GdkSurface * | gobj ()
| Provides access to the underlying C GObject.
const GdkSurface * | gobj () const
| Provides access to the underlying C GObject.
GdkSurface * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< Display > | get_display ()
| Gets the Gdk::Display associated with a Gdk::Surface.
Glib::RefPtr< const Display > | get_display () const
| Gets the Gdk::Display associated with a Gdk::Surface.
void | hide ()
| Hide the surface.
void | set_input_region (const ::Cairo::RefPtr< ::Cairo::Region > & region)
| Apply the region to the surface for the purpose of event handling.
bool | get_mapped () const
| Checks whether the surface has been mapped.
void | set_cursor (const Glib::RefPtr< Cursor > & cursor)
| Sets the default mouse pointer for a Gdk::Surface.
void | set_cursor ()
| Use the parent surface's cursor.
void | set_device_cursor (const Glib::RefPtr< Device > & device, const Glib::RefPtr< Cursor > & cursor)
| Sets a specific Gdk::Cursor for a given device when it gets inside surface.
Glib::RefPtr< Cursor > | get_device_cursor (const Glib::RefPtr< Device > & device)
| Retrieves a Gdk::Cursor pointer for the device currently set on the specified Gdk::Surface.
Glib::RefPtr< const Cursor > | get_device_cursor (const Glib::RefPtr< const Device > & device) const
| Retrieves a Gdk::Cursor pointer for the device currently set on the specified Gdk::Surface.
Glib::RefPtr< Cursor > | get_cursor ()
| Retrieves a Gdk::Cursor pointer for the cursor currently set on the Gdk::Surface.
Glib::RefPtr< const Cursor > | get_cursor () const
| Retrieves a Gdk::Cursor pointer for the cursor currently set on the Gdk::Surface.
int | get_width () const
| Returns the width of the given surface.
int | get_height () const
| Returns the height of the given surface.
bool | translate_coordinates (const Glib::RefPtr< const Surface > & to, double & x, double & y) const
| Translates coordinates between two surfaces.
int | get_scale_factor () const
| Returns the internal scale factor that maps from surface coordinates to the actual device pixels.
double | get_scale () const
| Returns the internal scale that maps from surface coordinates to the actual device pixels.
bool | get_device_position (const Glib::RefPtr< const Device > & device, double & x, double & y, ModifierType & mask) const
| Obtains the current device position and modifier state.
::Cairo::RefPtr< ::Cairo::Surface > | create_similar_surface (::Cairo::Content content, int width, int height)
| Create a new Cairo surface that is as compatible as possible with the given surface.
void | beep ()
| Emits a short beep associated to surface.
Glib::RefPtr< Drag > | drag_begin_from_point (const Glib::RefPtr< Device > & device, const Glib::RefPtr< ContentProvider > & content, DragAction actions, double dx, double dy)
| Starts a drag and creates a new drag context for it.
void | queue_render ()
| Forces a signal_render() signal emission for surface to be scheduled.
void | request_layout ()
| Request a layout phase from the surface's frame clock.
Glib::RefPtr< FrameClock > | get_frame_clock ()
| Gets the frame clock for the surface.
Glib::RefPtr< const FrameClock > | get_frame_clock () const
| Gets the frame clock for the surface.
void | set_opaque_region (const ::Cairo::RefPtr< const ::Cairo::Region > & region)
| Marks a region of the Gdk::Surface as opaque.
Glib::RefPtr< Gdk::GLContext > | create_gl_context ()
| Creates a new GLContext matching the framebuffer format to the visual of the Surface.
Glib::RefPtr< Gdk::CairoContext > | create_cairo_context ()
| Creates a new Gdk::CairoContext for rendering on surface.
Glib::SignalProxy< void(int, int)> | signal_layout ()
Glib::SignalProxy< bool(const ::Cairo::RefPtr< const ::Cairo::Region > &)> | signal_render ()
Glib::SignalProxy< bool(const Glib::RefPtr< const Event > &)> | signal_event ()
Glib::SignalProxy< void(const Glib::RefPtr< Monitor > &)> | signal_enter_monitor ()
Glib::SignalProxy< void(const Glib::RefPtr< Monitor > &)> | signal_leave_monitor ()
Glib::PropertyProxy< Glib::RefPtr< Cursor > > | property_cursor ()
| The mouse pointer for the Gdk::Surface.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Cursor > > | property_cursor () const
| The mouse pointer for the Gdk::Surface.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Display > > | property_display () const
| The Gdk::Display connection of the surface.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< FrameClock > > | property_frame_clock () const
| The Gdk::FrameClock of the surface.
Glib::PropertyProxy_ReadOnly< bool > | property_mapped () const
| Whether the surface is mapped.
Glib::PropertyProxy_ReadOnly< int > | property_width () const
| The width of the surface in pixels.
Glib::PropertyProxy_ReadOnly< int > | property_height () const
| The height of the surface, in pixels.
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the surface.
Glib::PropertyProxy_ReadOnly< double > | property_scale () const
| The scale of the surface.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Static Public Member Functions inherited from Gdk::DragSurface
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gdk::Surface
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< Surface > | create_toplevel (const Glib::RefPtr< Display > & display)
| Creates a new toplevel surface.
static Glib::RefPtr< Surface > | create_popup (const Glib::RefPtr< Surface > & parent, bool autohide)
| Create a new popup surface.
Protected Member Functions inherited from Gdk::DragSurface
| DragSurface ()
| You should derive from this class to use it.
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Related Symbols inherited from Gdk::DragSurface
Glib::RefPtr< Gdk::DragSurface > | wrap (GdkDragSurface * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gdk::Surface
Glib::RefPtr< Gdk::Surface > | wrap (GdkSurface * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Gdk::DragSurfaceImpl is a Gdk::Surface that implements the Gdk::DragSurface interface.

The GdkDragSurface interface can be implemented by C classes that derive from GdkSurface. No public GTK class implements GdkDragSurface. Some GTK functions, such as gdk_drag_get_drag_surface(), return an object of a class which is derived from GdkSurface and implements GdkDragSurface. Since that C class is not public, it's not wrapped in a C++ class. A C object of such a class can be wrapped in a Gdk::DragSurfaceImpl object. Gdk::DragSurfaceImpl does not directly correspond to any GTK class.

This class is intended only for wrapping C objects returned from GTK functions.

See also
  Gdk::Drag::get_drag_surface()

Since gtkmm 3.98

## Constructor & Destructor Documentation

## ◆ DragSurfaceImpl()

Gdk::DragSurfaceImpl::DragSurfaceImpl | ( | DragSurfaceImpl && | src | ) |
| noexcept

## ◆ ~DragSurfaceImpl()

Gdk::DragSurfaceImpl::~DragSurfaceImpl | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ operator=()

DragSurfaceImpl & Gdk::DragSurfaceImpl::operator= | ( | DragSurfaceImpl && | src | ) |
| noexcept